# Generated by Django 3.0.9 on 2020-08-26 18:48
from django.core.exceptions import ObjectDoesNotExist
from django.db import migrations
from django.db.models.signals import pre_save
from edc_utils import DisableSignals


def update_appointments(apps, schema_editor):
    registered_subject_model_cls = apps.get_model("edc_registration.registeredsubject")
    appointment_model_cls = apps.get_model("edc_appointment.appointment")
    subject_visit_model_cls = apps.get_model("inte_subject.subjectvisit")
    crfmetadata_model_cls = apps.get_model("edc_metadata.crfmetadata")
    for registered_subject in registered_subject_model_cls.objects.all():
        for index, appointment in enumerate(
            appointment_model_cls.objects.filter(
                subject_identifier=registered_subject.subject_identifier
            ).order_by("timepoint")
        ):
            if appointment.timepoint in [0, 6, 12]:
                continue
            elif appointment.timepoint < 6:
                appointment.visit_code = "1000"
                appointment.visit_code_sequence = index
                appointment.timepoint = 0
                with DisableSignals(disabled_signals=[pre_save]):
                    appointment.save()
                appointment.refresh_from_db()
                try:
                    subject_visit = subject_visit_model_cls.objects.get(
                        appointment=appointment
                    )
                except ObjectDoesNotExist:
                    appointment.delete()
                else:
                    crfmetadata_model_cls.objects.filter(
                        subject_identifier=registered_subject.subject_identifier,
                        visit_code=subject_visit.visit_code,
                        visit_code_sequence=subject_visit.visit_code_sequence,
                    ).update(
                        visit_code=appointment.visit_code,
                        visit_code_sequence=appointment.visit_code_sequence,
                        timepoint=appointment.timepoint,
                    )
                    with DisableSignals(disabled_signals=[pre_save]):
                        subject_visit.visit_code = appointment.visit_code
                        subject_visit.visit_code_sequence = (
                            appointment.visit_code_sequence
                        )
                        subject_visit.save()
            else:
                appointment.delete()

    for appointment in appointment_model_cls.objects.filter(visit_code_sequence__gt=0):
        try:
            subject_visit_model_cls.objects.get(appointment=appointment)
        except ObjectDoesNotExist:
            appointment.delete()


class Migration(migrations.Migration):

    dependencies = [
        ("edc_appointment", "0024_auto_20200911_0425"),
        ("inte_subject", "0042_auto_20200826_1924"),
    ]

    operations = [migrations.RunPython(update_appointments)]
